﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*Search and replace in a Word document - by srod.
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"

Define WordApplication.COMateObject 

#wdReplaceAll  = 2
  
inputDoc$ = "c:\testIN.doc"
outputDoc$ = "c:\testOUT.doc"

search$ = "is"
replace$ = "IS"


WordApplication = COMate_CreateObject("Word.Application") 
    
If WordApplication 
  If WordApplication\Invoke("Documents\Open('" + inputDoc$ + "')") = #S_OK 
    WordApplication\Invoke("Selection\GoTo(1)")
    WordApplication\SetProperty("Selection\Find\MatchWholeWord = #True")
    WordApplication\SetProperty("Selection\Find\Forward = #True")
    WordApplication\SetProperty("Selection\Find\Text = '" + search$ + "'")
    WordApplication\Invoke("Selection\Find\Execute(#Opt, #Opt, #Opt, #Opt, #Opt, #Opt, #Opt, #Opt, #Opt, '" + replace$ + "', " + Str(#wdReplaceAll) + ")")
    WordApplication\Invoke("ActiveDocument\SaveAs('" + outputDoc$ + "')")
    WordApplication\Invoke("Quit(0)") 
  Else 
    MessageRequester("COMate -search and replace text in word document!", "Couldn't load the document!")
  EndIf 
  WordApplication\Release() 
Else 
  MessageRequester("COMate -search and replace text in word document!", "Couldn't create the application object!")
EndIf


;
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 14
; FirstLine = 10
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll