;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*WMI demo - list printers and supported paper types.
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"
XIncludeFile "VariantHelper_Include.pb" 


Procedure Get_Printers() 
  Protected objWMIService.COMateObject, printer.COMateObject 
  Protected colPrinter.COMateEnumObject
  Protected *var.variant, *varPaper.VARIANT
  Protected *sa.SafeArray, i

  strComputer.s = "." 
  objWMIService = COMate_GetObject("winmgmts:\\" + strComputer + "\root\cimv2", "") 
  If objWMIService 
    colPrinter = objWMIService\CreateEnumeration("ExecQuery('Select * FROM Win32_Printer')") 
    If colPrinter 
      printer = colPrinter\GetNextObject() 
      While printer 
        Debug "Name        =  " + printer\GetStringProperty("Name") 
        Debug "===========================================" 
        Debug "Supported paper types :"
        *var = printer\GetVariantProperty("PrinterPaperNames") 
        If *var
          If *var\vt <> #VT_NULL 
            *sa = *var\parray 
            For i = saLBound(*sa) To saUBound(*sa) 
              *varPaper = SA_VARIANT(*sa, i) 
              If *varPaper\vt <> #VT_BSTR 
                VariantChangeType_(*varPaper, *varPaper, 0, #VT_BSTR) 
              EndIf 
              Debug "    " + PeekS(*varPaper\bstrVal, -1, #PB_Unicode) 
            Next
            saFreeSafeArray(*sa) ;This will clear all variants within the safe array.
          EndIf
          VariantClear_(*var)
          FreeMemory(*var)
        EndIf
        Debug "===========================================" 
        printer\Release() 
        printer = colPrinter\GetNextObject() 
      Wend 
      colPrinter\Release() 
    EndIf 
    objWMIService\Release()  
  EndIf 
EndProcedure 

Get_Printers()
; IDE Options = PureBasic 4.61 Beta 1 (Windows - x86)
; CursorPosition = 9
; FirstLine = 9
; Folding = -
; EnableXP