﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*MSComctLib_TreeCtrl demo 2 (with events!) - by ???
;*This demo may not run correctly on XP with service pack 2. This is a known issue!
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "flexcell.pbi"
IncludePath "..\..\"
XIncludeFile "COMate.pbi"

Global              iGrid.COMateObject
Define.i            blnRegister, FontSize 
Define.s            FontName.s

Procedure           SetRowHeight( Row1.i, Row2.i, Height.i )
    Protected       i.i
    
    iGrid\Invoke( "AutoRedraw = #False" )
    
    For i = Row1 To Row2
      iGrid\SetProperty( "RowHeight(" + Str( i ) +") = " + Str( Height ) )
    Next
    
    iGrid\Invoke( "AutoRedraw = #True" )
    iGrid\Invoke( "Refresh" )
    
EndProcedure
   
Procedure            EventProc( FlexObject.COMateObject, eventName$, parameterCount )
  Protected          *ptrBoolean.WORD, newRow, newColumn
  Protected          URL.s, image.s
  Protected          combo.COMateObject
  Protected          *ptrBSTR.INTEGER
  
  ;Debug eventName$  
  If eventName$ = "ButtonClick"
    
      Select FlexObject\GetIntegerEventParam(1)
        Case 3 ;BackColor
          iGrid\SetProperty( "ActiveCell\Text = '&HFFFFFF'" )
        Case 6 ;FillColor
          iGrid\SetProperty( "ActiveCell\Text = '&HFFFFFF'" )
        Case 8 ;ForeColor
          iGrid\SetProperty( "ActiveCell\Text = '&H000000'" )
        Case 9 ;Picture
          iGrid\SetProperty( "ActiveCell\Text = '(None)'" )
        Case 16 ;Font
          iGrid\SetProperty( "ActiveCell\Text = 'Ariel'" )          
      EndSelect
      
  ElseIf eventName$ = "Click"
      image = iGrid\GetStringProperty( "ActiveCell\ImageKey" )
      
      If image = "Image1"
         iGrid\Invoke( "ActiveCell\SetImage( 'Image2' )" )

         Select iGrid\GetIntegerProperty( "ActiveCell\Row" )
            Case 1
               SetRowHeight( 2, 9, 18 )
            Case 10
               SetRowHeight( 11, 14, 18 )
            Case 15
               SetRowHeight( 16, 16, 18 )
            Case 17
               SetRowHeight( 18, 21, 18 )
            Case 22
               SetRowHeight( 23, 25, 18 )
         EndSelect
      ElseIf image = "Image2"
         iGrid\Invoke( "ActiveCell\SetImage( 'Image1' )" )
         
         Select iGrid\GetIntegerProperty( "ActiveCell\Row" )
            Case 1
               SetRowHeight( 2, 9, 0 )
            Case 10
               SetRowHeight( 11, 14, 0 )
            Case 15
               SetRowHeight( 16, 16, 0 )
            Case 17
               SetRowHeight( 18, 21, 0 )
            Case 22
               SetRowHeight( 23, 25, 0 )
         EndSelect
      EndIf
      
  ElseIf eventName$ = "ComboDropDown"
    
    Select  FlexObject\GetIntegerEventParam( 1 )
      Case 2 ;Appearance          
          combo = iGrid\GetObjectProperty( "ComboBox(0)" )
          combo\Invoke( "AddItem( '0 - Flat' )" )
          combo\Invoke( "AddItem( '1 - 3D' )" )
          combo\Release()
          
      Case 4 ;BorderStyle
          combo = iGrid\GetObjectProperty( "ComboBox(0)" )
          combo\Invoke( "AddItem( '0 - None' )" )
          combo\Invoke( "AddItem( '1 - Fixed Single' )" )
          combo\Invoke( "AddItem( '2 - Sizable' )" )
          combo\Invoke( "AddItem( '3 - Fixed Dialog' )" )
          combo\Invoke( "AddItem( '4 - Fixed ToolWindow' )" )
          combo\Invoke( "AddItem( '5 - Sizable ToolWindow' )" )
          combo\Release()
      Case 7 ;FillStyle
          combo = iGrid\GetObjectProperty( "ComboBox(0)" )
          combo\Invoke( "AddItem( '0 - Solid' )" )
          combo\Invoke( "AddItem( '1 - Transparent' )" )
          combo\Release()
      Case 11,12,13, 14
          combo = iGrid\GetObjectProperty( "ComboBox(0)" )
          combo\Invoke( "AddItem( 'True' )" )
          combo\Invoke( "AddItem( 'False' )" )
          combo\Release()
    EndSelect
      
  ElseIf eventName$ = "HyperLinkClick"
      newRow    = FlexObject\GetIntegerEventParam(1) 
      newColumn = FlexObject\GetIntegerEventParam(2) 
      FlexObject\IsEventParamPassedByRef(3, @*ptrBSTR) 
      If *ptrBSTR 
        If *ptrBSTR\i 
          SysFreeString_(*ptrBSTR\i) 
        EndIf
        URL = iGrid\GetStringProperty( "Cell(" + Str(newRow) + ", " + Str(newColumn) + ")\Tag" )
        *ptrBSTR\i = COMate_MakeBSTR( URL )
      EndIf 
      FlexObject\IsEventParamPassedByRef(4, @*ptrBoolean) 
      If *ptrBoolean 
        *ptrBoolean\w = #VARIANT_TRUE 
      EndIf 
      ;About FlexCell 
      If newRow = 25 And newColumn = 3 
        iGrid\Invoke( "AboutBox" ) 
      EndIf 
;      URL       = FlexObject\GetStringProperty( "Cell(" + Str(newRow) + ", " + Str(newColumn) + ")\Tag" ) 

  EndIf
  
EndProcedure



If OpenWindow(0, #PB_Ignore, #PB_Ignore, 360, 490, "COMate - FlexCell")

  StringGadget(1, 5, 5, 340, 20,"")
  
  iGrid = COMate_CreateActiveXControl( 5, 30, 350, 500, "FlexCell.Grid")
  ;iGrid = COMate_CreateActiveXControl( 5, 20, 350, 400, "10Tec iGrid Control 3.0")
  ;10Tec iGrid Control 3.0
  
  If Not iGrid 
    If COMate_RegisterCOMServer("FlexCell.ocx") = #S_OK
      blnRegister = #True
      iGrid = COMate_CreateActiveXControl( 5, 30, 350, 500, "FlexCell.Grid")
    EndIf  
  EndIf

  If iGrid
    ;iGrid\Invoke( "SetRegisterInformation( 'EN010B','B3SBS-PQE7G-KW65P-83BKO-XJCGU' )" )
    ;iGrid\Invoke( "AboutBox()" )
    iGrid\SetProperty( "Cols = 4" )
    iGrid\SetProperty( "Rows = 26" )
    iGrid\SetProperty( "AutoRedraw = #False" )
    iGrid\SetProperty( "DisplayFocusRect = 0" )
    iGrid\SetProperty( "ButtonLocked = 1" )
    iGrid\SetProperty( "ExtendLastCol = 1" )
    iGrid\SetProperty( "ReadOnlyFocusRect = 0" )
    iGrid\SetProperty( "ScrollBars = 2" )
    iGrid\SetProperty( "SelectionMode = 3" )
    iGrid\SetProperty( "CellBorderColorFixed = " + Str( RGB(80,80,80 ) ) )
    
    iGrid\SetProperty( "Column(0)\Width = 0" )
    iGrid\SetProperty( "RowHeight(0) = 0" )
    
    
    iGrid\SetProperty( "Range(1, 1, 25,1)\Alignment = 10" )
    iGrid\SetProperty( "Range(1, 1, 25,1)\BackColor = " + Str( RGB( 220, 128, 160 ) ) )
    
    iGrid\Invoke( "Images\Add( 'Image1.bmp','Image1' )" )
    iGrid\Invoke( "Images\Add( 'Image2.bmp','Image2' )" )
    
    iGrid\Invoke( "Cell(1, 1)\SetImage( 'Image2' )" )
    iGrid\SetProperty( "Cell(1, 2)\Text( 'Appearance' )" )
    iGrid\SetProperty( "Cell(1, 2)\Font\Bold = #True" )
    iGrid\Invoke( "Range(1, 2, 1, 3)\Merge" )
    
    iGrid\SetProperty( "Cell(2, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(4, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(7, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(3, 3)\CellType = 4" )
    iGrid\SetProperty( "Cell(6, 3)\CellType = 4" )
    iGrid\SetProperty( "Cell(8, 3)\CellType = 4" )
    iGrid\SetProperty( "Cell(9, 3)\CellType = 4" )
    
    ; Appearance
    iGrid\SetProperty( "Cell(2, 2)\Text = 'Appearance'" )
    iGrid\SetProperty( "Cell(2, 3)\Text = '1 - 3D'" )
    iGrid\SetProperty( "Cell(3, 2)\Text = 'BackColor'" )
    iGrid\SetProperty( "Cell(3, 3)\Text = '&HFFFFFF'" )
    iGrid\SetProperty( "Cell(4, 2)\Text = 'BorderStyle'" )
    iGrid\SetProperty( "Cell(4, 3)\Text = '0 - None'" )
    iGrid\SetProperty( "Cell(5, 2)\Text = 'Caption'" )
    iGrid\SetProperty( "Cell(5, 3)\Text = 'Form1'" )
    iGrid\SetProperty( "Cell(6, 2)\Text = 'FillColor'" )
    iGrid\SetProperty( "Cell(6, 3)\Text = '&HFFFFFF'" )
    iGrid\SetProperty( "Cell(7, 2)\Text = 'FillStyle'" )
    iGrid\SetProperty( "Cell(7, 3)\Text = '0 - Solid'" )
    iGrid\SetProperty( "Cell(8, 2)\Text = 'ForeColor'" )
    iGrid\SetProperty( "Cell(8, 3)\Text = '&H000000'" )
    iGrid\SetProperty( "Cell(9, 2)\Text = 'Picture'" )
    iGrid\SetProperty( "Cell(9, 3)\Text = 'Image1.bmp'" )
    
   
    ;Behavior    
    iGrid\Invoke( "Cell(10, 1)\SetImage( 'Image2' )" )
    iGrid\SetProperty( "Cell(10, 2)\Text = 'Behavior'" )
    iGrid\SetProperty( "Cell(10, 2)\Font\Bold = #True" )
    iGrid\Invoke( "Range( 10, 2, 10, 3 )\Merge" )   
    
    iGrid\SetProperty( "Cell(12, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(13, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(14, 3)\CellType = 1" )
    iGrid\SetProperty( "Cell(11, 3)\CellType = 1" )
    
    iGrid\SetProperty( "Cell(11, 2)\Text = 'AutoRedraw'" )
    iGrid\SetProperty( "Cell(11, 3)\Text = 'False'" )
    iGrid\SetProperty( "Cell(12, 2)\Text = 'ClipControls'" )
    iGrid\SetProperty( "Cell(12, 3)\Text = 'True'" )
    iGrid\SetProperty( "Cell(13, 2)\Text = 'Enabled'" )
    iGrid\SetProperty( "Cell(13, 3)\Text = 'True'" )
    iGrid\SetProperty( "Cell(14, 2)\Text = 'Visible'" )
    iGrid\SetProperty( "Cell(14, 3)\Text = 'True'" )
   
    ;Font
    iGrid\Invoke( "Cell(15, 1)\SetImage( 'Image2' )" )
    iGrid\SetProperty( "Cell(15, 2)\Text = 'Font'" )
    iGrid\SetProperty( "Cell(15, 2)\Font\Bold = #True" )
    iGrid\Invoke( "Range( 15, 2, 15, 3 )\Merge" )      
    
    iGrid\SetProperty( "Cell(16, 3)\CellType = 4" )
    iGrid\SetProperty( "Cell(16, 2)\Text = 'Font'" )
    iGrid\SetProperty( "Cell(16, 3)\Text = 'Tahoma'" )
    
    iGrid\Invoke( "Cell(17, 1)\SetImage( 'Image2' )" )
    iGrid\SetProperty( "Cell(17, 2)\Text = 'Position'" )
    iGrid\SetProperty( "Cell(17, 2)\Font\Bold = #True" )
    iGrid\Invoke( "Range( 17, 2, 17, 3 )\Merge" )
    
    iGrid\SetProperty( "Cell(18, 2)\Text = 'Height'" )
    iGrid\SetProperty( "Cell(18, 3)\Text = '2000'" )
    iGrid\SetProperty( "Cell(19, 2)\Text = 'Left'" )
    iGrid\SetProperty( "Cell(19, 3)\Text = '280'" )
    iGrid\SetProperty( "Cell(20, 2)\Text = 'Top'" )
    iGrid\SetProperty( "Cell(20, 3)\Text = '360'" )
    iGrid\SetProperty( "Cell(21, 2)\Text = 'Width'" )
    iGrid\SetProperty( "Cell(21, 3)\Text = '3600'" )
    
    iGrid\Invoke( "Cell(22, 1)\SetImage( 'Image2' )" )
    iGrid\SetProperty( "Cell(22, 2)\Text = 'Other'" )
    iGrid\SetProperty( "Cell(22, 2)\Font\Bold = #True" )
    iGrid\Invoke( "Range( 22, 2, 22, 3 )\Merge" )
    
    iGrid\SetProperty( "Cell(23, 2)\Text = 'HomePage'" )    
    iGrid\SetProperty( "Cell(23, 3)\Text = 'FlexCell Studio'" )    
    iGrid\SetProperty( "Cell(23, 3)\Tag = 'http://www.grid2000.com'" )
    iGrid\SetProperty( "Cell(24, 2)\Text = 'Email'" )    
    iGrid\SetProperty( "Cell(24, 3)\Text = 'Contact Us'" )    
    iGrid\SetProperty( "Cell(24, 3)\Tag = 'mailto:support@grid2000.com'" )    
    iGrid\SetProperty( "Cell(25, 2)\Text = 'Other'" )
    iGrid\SetProperty( "Cell(25, 3)\Text = 'About FlexCell'" )
    iGrid\SetProperty( "Cell(25, 3)\Tag = #nullstring" )
    iGrid\SetProperty( "Range( 23, 3, 25, 3 )\CellType = 5" )
    iGrid\SetProperty( "Range( 23, 3, 25, 3 )\ForeColor = " + Str( RGB( 0, 0, 200 ) ) )
  
    iGrid\SetProperty( "Column(1)\Width = 18" )
    iGrid\SetProperty( "Column(2)\Width = 80" )
    iGrid\SetProperty( "Column(3)\Width = 80" )
    iGrid\SetProperty( "Column(1)\Locked = #True" )
    iGrid\SetProperty( "Column(2)\Locked = #True" )
    
    iGrid\SetProperty( "ComboBox(0)\Locked = #True" )
    FontName = iGrid\GetStringProperty( "DefaultFont\Name" )
    FontSize = iGrid\GetIntegerProperty( "DefaultFont\Size" )
    iGrid\SetProperty( "ComboBox(0)\Font\Name = '" + FontName + "'" )
    iGrid\SetProperty( "ComboBox(0)\Font\Size = " + Str( FontSize ) )
    
    
    ;Debug COMate_GetLastErrorDescription()
    
    iGrid\SetProperty( "AutoRedraw = #True" )
    iGrid\Invoke( "Refresh" )
    iGrid\SetEventHandler("", @EventProc() )
    
    ;iGrid\Invoke( "OpenFile('Sample.cel')" )
    ;iGrid\Invoke( "ExportToPdf('Sample1.pdf')" )

    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_CloseWindow
          Break
        Case #PB_Event_Gadget
          Select EventGadget()
            Case 1
            If EventType() = #PB_EventType_Change
              
            EndIf
          EndSelect
      EndSelect
    ForEver
    ;treeViewObject\Release()
  Else
    MessageRequester("COMate - TreeView ActiveX demo", "Couldn't create the ActiveX control!")
  EndIf
  
  If blnRegister
    COMate_UnRegisterCOMServer( "FlexCell.ocx" )
  EndIf
  
  CloseWindow(0)

EndIf




; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 293
; FirstLine = 280
; Folding = -
; EnableXP