﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*MSComctLib_TreeCtrl demo 1 (no events!) - by ???
;*This demo may not run correctly on XP with service pack 2. This is a known issue!
;/////////////////////////////////////////////////////////////////////////////////

IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"

Enumeration ; Relationship
  #tvwFirst
  #tvwLast
  #tvwNext
  #tvwPrevious
  #tvwChild
EndEnumeration

Define.COMateObject treeViewObject, treeNodeObject


;/////////////////////////////////////////////////////////////////////////////////
;The following utility adds a new node to the tree.
Procedure.l TreeviewNodesAdd(treeViewObject.COMateObject, Relative.s = "", Relationship.l = -1, key.s = "", Text.s = "")
  Protected treeNodeObject.COMateObject
  treeNodeObject = treeViewObject\GetObjectProperty("Nodes\Add('" + Relative + "', " + Str(Relationship) + ", '" + key + "', '" + Text + "')")
  ProcedureReturn treeNodeObject
EndProcedure
;/////////////////////////////////////////////////////////////////////////////////


If OpenWindow(0, #PB_Ignore, #PB_Ignore, 350, 400, "COMate - TreeView ActiveX demo 1 (no events!)")    

  StringGadget(1, 5, 5, 340, 20,"")
  
  treeViewObject = COMate_CreateActiveXControl(5, 30, 340, 365, "MSComctlLib.TreeCtrl")

  If treeViewObject
    treeViewObject\SetProperty("HideSelection = #False")
    treeViewObject\SetProperty("LabelEdit = 1") ;Change to zero for automatic one-click editing.

    ;Add Rootnode
      treeNodeObject = treeViewObject\GetObjectProperty("Nodes\Add")
      treeNodeObject\SetProperty("Text = 'Root'")
      treeNodeObject\SetProperty("Key = 'root'")
      treeNodeObject\SetProperty("Expanded = #True")
        treeNodeObject\Release()

    ;Add First SubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "root", #tvwChild, "animals", "Animals")
      treeNodeObject\SetProperty("Expanded=#True")
        treeNodeObject\Release()

    ;Add First SubSubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "animals", #tvwChild, "cats", "Cats")
        treeNodeObject\Release()
    ;Add Second SubSubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "animals", #tvwChild, "dogs", "Dogs")
        treeNodeObject\Release()

    ;Add First SubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "root", #tvwChild, "cars", "Cars")
      treeNodeObject\SetProperty("Expanded=#True")
        treeNodeObject\Release()

    ;Add First SubSubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "cars", #tvwChild, "ferrari", "Ferrari")
        treeNodeObject\Release()
    ;Add Second SubSubNode
      treeNodeObject = TreeviewNodesAdd(treeViewObject, "cars", #tvwChild, "lamborghini", "Lamborghini")
        treeNodeObject\Release()

    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_CloseWindow
          Break
        Case #PB_Event_Gadget
          Select EventGadget()
            Case 1
            If EventType() = #PB_EventType_Change
              treeNodeObject = treeViewObject\GetObjectProperty("SelectedItem")
              If treeNodeObject
                NewNodeText$=GetGadgetText(1)
                treeNodeObject\SetProperty("Text = '" + NewNodeText$ + "'")
                treeNodeObject\Release()
              EndIf
            EndIf
          EndSelect
      EndSelect
    ForEver
    treeViewObject\Release()
  Else
    MessageRequester("COMate - TreeView ActiveX demo", "Couldn't create the ActiveX control!")
  EndIf    
  CloseWindow(0)

EndIf




; IDE Options = PureBasic 4.31 Beta 1 (Windows - x86)
; CursorPosition = 36
; Folding = -
; EnableXP
; HideErrorLog